function [A B] = functionX(C, D, E)
% (C) 2012, Datenverarbeitung in der Konstruktion, TU Darmstadt

% Author:   Andr Picard
% Date:     22.11.2012
% Version:  1.0
%

    %% Clean up
    clc;
    if exist('pathA', 'file')
        rmpath([pwd '/pathA']);
    end

    %% Check parameters
    if nargin < 1
        error('de:tudarmstadt:dik', 'Zu wenig Parameter!');
        errordlg('de:tudarmstadt:dik', 'Zu wenig Parameter!');
    end
    
    if nargout == 1
        A = 'Rckgabewert 1';
    elseif nargout == 2
        B = 'Rckgabewert 2';
    end
    name = mfilename;

    %% Inner function
    text = functionX1();
    disp(text);

    %% Internal function
    text = functionX2();
    disp(text);
    disp(' ');

    %% Search Path
    try
        text = functionA();
        disp(text);
    catch
        disp('Catch: functionA has not been found in search path. Adding to search path');
        addpath([pwd '/pathA']);
    end
    disp(functionA());

    %% Private search path
    text = functionB();
    disp(text);

    %% Package function
    text = pathC.functionC();
    disp(text);
    disp(' ');

    %% Anonymous function
    text = @(parameter)(['Anonymous function has been found in "' parameter '".']);
    disp(text(mfilename));

    
    function rueck = functionX1()
        rueck = ['Inner function has been found in "' name '".'];
    end
end

function rueck = functionX2()
    rueck = ['Internal function has been found in "' mfilename '".'];
end